//+------------------------------------------------------------------+
//|                                                        FX_EA.MQ4 |
//|                                                                  |
//|                                             forexea333@gmail.com |
//+------------------------------------------------------------------+


#property copyright "forexea333@gmail.com"
#property link      ""


#include <stdlib.mqh>
#property strict


#import "kernel32.dll"
int CreateFileW(string,uint,int,int,int,int,int);
int GetFileSize(int,int);
int SetFilePointer(int,int,int&[],int);
int ReadFile(int,uchar&[],int,int&[],int);
int CloseHandle(int);
#import

extern string Ordercomment="FX_EA";
extern bool   ecnBroker=false;
extern int MagicID=123;
extern double SL=80;
extern  double TP=100;
extern int TrailingStop=7;
extern double TrailingStep  =0.5;
extern double TrailStart  =1.0;
extern int Slippage=3;
extern bool UseMM=true;
extern double Lots=0.1;
extern double MinLots = 0.01;
extern double MaxLots = 100000.0;
extern double Risk=40;

int   previousBar=0;
int BytesToRead=0;
int hst_handle;
string result;
string account_server,datapath;
int    Retries=10;
int    currentTicket=0;
double MyPoint;
int pm;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
union Price
  {
   uchar             buffer[8];
   double            close;
  };

Price price;

double data[][2];
bool showalert;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {

   if(Digits==3 || Digits==5)
     {
      pm=10;
     }
   else if(Digits==2 || Digits==4)
     {
      pm=1;
     }
   MyPoint=pm*Point;

   Slippage*=pm;

   account_server=AccountInfoString(ACCOUNT_SERVER);
   if(account_server=="") account_server="default";

   datapath=TerminalInfoString(TERMINAL_DATA_PATH)+"\\history\\"+
            account_server+"\\"+Symbol()+"240"+".hst";

   result=ReadFileHst(datapath);
   
    

   previousBar=Bars;

   showalert=true;

   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   Comment("");
   ChartRedraw(0);

   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {

   double BuySL=0,BuyTP=0,SellSL=0,SellTP=0;

   RefreshRates();
   
   if(BytesToRead>0)Comment("History data loaded");
    
   if(previousBar!=Bars)
     {
      previousBar=Bars;
     }
   else
     {
      return;
     }
     
   

   if(BytesToRead>0)
     {
      int pos=-1;
      for(int i=0;i<BytesToRead-1;i++)
        {
         if(data[i][0]<Time[0])

           {
            pos=i+1;
           }
         else break;

        }

      

      double OsMA = iOsMA(Symbol(),PERIOD_M15,12,26,8,PRICE_TYPICAL,0);
      double wpr = iWPR(Symbol(),0,2,0);
      double ao=iAO(Symbol(),0,0);

      if(pos>0)
        {

         if(CheckMarketBuyOrders()==0 && CheckMarketSellOrders()==0)
           {
            if(data[pos][1]>Open[0]
             && ao>0
             && OsMA>0
             && wpr<-98
               )
              {
               if(SL==0)BuySL=0;
               else
                  BuySL=NormalizeDouble(Ask-SL*MyPoint,Digits);
               if(TP==0)BuyTP=0;
               else
                  BuyTP=NormalizeDouble(Ask+TP*MyPoint,Digits);

               MainOrders(0,Ask,BuyTP,BuySL);
              }

            if(data[pos][1]<Open[0]
             && ao<0
             && OsMA<0
             && wpr>-2
               )
              {
               if(SL==0)BuySL=0;
               else
                  SellSL=NormalizeDouble(Bid+SL*MyPoint,Digits);
               if(TP==0)SellTP=0;
               else
                  SellTP=NormalizeDouble(Bid-TP*MyPoint,Digits);
               MainOrders(1,Bid,SellTP,SellSL);
              }
           }

        }

     }
   else
     {
      if(showalert)Alert("Allow DLL imports and download history data for "+Symbol());
      showalert=false;

     }
   Trailing();
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ReadFileHst(string Filename)
  {

   int j=0;

   string strFileContents="";
   int Handle=CreateFileW(Filename,0x80000000,3,0,3,0,0);
   if(Handle==-1)
     {
      Print("Error open history!");
      return ("");
     }
   else
     {
      int LogFileSize=GetFileSize(Handle,0);

      if(LogFileSize<=0)
        {
         return ("");
        }

      else
        {

         int movehigh[1];

         SetFilePointer(Handle,148,movehigh,0);

         uchar buffer[];
         BytesToRead=(LogFileSize-148)/60;

         ArrayResize(data,BytesToRead);

         int nNumberOfBytesToRead=60;

         ArrayResize(buffer,nNumberOfBytesToRead);
         int read[1];

         for(int i=0;i<BytesToRead;i++)
           {
            ReadFile(Handle,buffer,nNumberOfBytesToRead,read,0);
            if(read[0]==nNumberOfBytesToRead)
              {
               result="";
               result=StringFormat("0x%02x%02x%02x%02x%02x%02x%02x%02x",buffer[7],buffer[6],buffer[5],buffer[4],buffer[3],buffer[2],buffer[1],buffer[0]);

               price.buffer[0]=buffer[32];
               price.buffer[1]=buffer[33];
               price.buffer[2]=buffer[34];
               price.buffer[3]=buffer[35];
               price.buffer[4]=buffer[36];
               price.buffer[5]=buffer[37];
               price.buffer[6]=buffer[38];
               price.buffer[7]=buffer[39];



               double mm=price.close;

               data[j][0]=StrToDouble(result);
               data[j][1]=mm;
               j++;

               strFileContents=TimeToStr((datetime)StrToDouble(result),TIME_DATE|TIME_MINUTES)+" "+DoubleToStr(mm,8);
              }
            else
              {
               CloseHandle(Handle);
               return ("");
              }
           }
        }

      CloseHandle(Handle);
     }

   strFileContents=TimeToStr((datetime)(data[j-1][0]),TIME_DATE|TIME_MINUTES)+" "+DoubleToStr(data[j-1][1],8)+" "+
                   TimeToStr((datetime)(data[j-2][0]),TIME_DATE|TIME_MINUTES)+" "+DoubleToStr(data[j-2][1],8);

   return strFileContents;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int fnGetLotDigit()
  {
   double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   if(LotStep == 1)      return(0);
   if(LotStep == 0.1)    return(1);
   if(LotStep == 0.01)   return(2);
   if(LotStep == 0.001)  return(3);
   if(LotStep == 0.0001) return(4);
   return(1);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int CheckMarketSellOrders()
  {
   int op=0;

   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      int status=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()!=MagicID) continue;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_SELL)
           {
            op++;
           }
        }
     }
   return(op);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CheckMarketBuyOrders()
  {
   int op=0;

   for(int i=OrdersTotal()-1;i>=0;i--)

     {
      int status=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()!=MagicID) continue;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
           {
            op++;
           }
        }
     }
   return(op);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool MainOrders(int type,double open_price,double price_TP,double price_SL)
  {
   color color_8=Black;
   int bClosed;
   int nAttemptsLeft=Retries;
   int cmd=0;

   if(type ==OP_BUY||type ==OP_BUYSTOP)   cmd=0;
   if(type ==OP_SELL||type ==OP_SELLSTOP) cmd=1;
   if(type==OP_BUYLIMIT || type==OP_BUY)
     {
      color_8=Blue;
        } else {
      if(type==OP_SELLLIMIT || type==OP_SELL)
        {
         color_8=Red;
        }
     }

   double lot=GetLots();

   if(lot==0.0) return(0);
   

   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);

   if(lot > maxlot) lot = maxlot;
   if(lot < minlot) lot = minlot;

   string comment=IntegerToString(MagicID)+"-"+Ordercomment;

   bClosed=false;

   while((bClosed==false) && (nAttemptsLeft>=0))
     {
      nAttemptsLeft--;
      RefreshRates();

      if(!ecnBroker)
         bClosed=OrderSend(Symbol(),type,lot,open_price,Slippage,price_SL,price_TP,comment,MagicID,0,color_8);
      else
        {
         bClosed=OrderSend(Symbol(),type,lot,open_price,Slippage,0,0,comment,MagicID,0,color_8);
         if(bClosed>0)
           {
            if(OrderSelect(bClosed,SELECT_BY_TICKET))
               bool mod=OrderModify(OrderTicket(),OrderOpenPrice(),price_SL,price_TP,0,color_8);
           }
        }
      if(bClosed<=0)
        {
         int nErrResult=GetLastError();

         if(type==0)
           {
            Print("EA Open New Buy FAILED : Error "+IntegerToString(nErrResult)+" ["+ErrorDescription(nErrResult)+".]");
            Print(IntegerToString(type)+" "+DoubleToString(lot,2)+" "+DoubleToString(open_price,Digits));
           }
         else
           {
            if(type==1)
              {
               Print("EA Open New Sell FAILED : Error "+IntegerToString(nErrResult)+" ["+ErrorDescription(nErrResult)+".]");
               Print(IntegerToString(type)+" "+DoubleToString(lot,2)+" "+DoubleToString(open_price,Digits));
              }
           }

         if(nErrResult == ERR_TRADE_CONTEXT_BUSY ||
            nErrResult == ERR_NO_CONNECTION)
           {
            Sleep(50);
            continue;
           }
        }

      currentTicket=bClosed;

      bClosed=true;

     }

   return(true);
  }
//+------------------------------------------------------------------+  
//Get Lot Size
double GetLots()

  {
   double lotfactor;
   double ilots;
   bool inclot = true;
   double lotstep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lotstep1= MathLog(lotstep)/MathLog(0.1);
   double minlots = MathMax(MinLots, MarketInfo(Symbol(), MODE_MINLOT));
   double maxlots = MathMin(MaxLots, MarketInfo(Symbol(), MODE_MAXLOT));
   double risk=Risk/100.0;

   lotfactor=AccountEquity()*100*risk;

   ilots=NormalizeDouble(lotfactor/MarketInfo(Symbol(),MODE_LOTSIZE),(int)lotstep1);
   ilots=MathMin(maxlots,ilots);
   ilots=MathMax(minlots,ilots);
   ilots=NormalizeDouble(ilots,2);
   double lot=MathFloor(ilots);
   while(inclot)
     {
      lot+=minlots;
      if(lot>ilots)
        {
         inclot=FALSE;
         lot-=minlots;
        }
     }

   if(UseMM==FALSE) ilots=Lots;

   return(ilots);

  }
//+------------------------------------------------------------------+
void Trailing()
  {
   for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol() && OrderMagicNumber()==MagicID )  // check for symbol
        {
         //--- long position is opened
         if(OrderType()==OP_BUY)
           {

            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if(Bid-(OrderOpenPrice()-TrailStart*MyPoint) > MyPoint*TrailingStop )
                 {
                  if(OrderStopLoss()<Bid-MyPoint*(TrailingStop+TrailingStep-1)||(OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-MyPoint*TrailingStop,OrderTakeProfit(),0,Green))
                        Print("OrderModify error ",GetLastError());
                        Sleep(500);
                        RefreshRates();
                        
                     return;
                    }
                 }
              }
           }
           
         else // go to short position
           {

            //--- check for trailing stop
            if(TrailingStop>0)
              {
               if((OrderOpenPrice()-(Ask-TrailStart*MyPoint))>(MyPoint*TrailingStop))
                 {
                  if(OrderStopLoss()>(Ask+MyPoint*(TrailingStop+TrailingStep+1))||(OrderStopLoss()==0))
                    {
                     //--- modify order and exit
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+MyPoint*TrailingStop,OrderTakeProfit(),0,Red))
                        Print("OrderModify error ",GetLastError());
                        Sleep(500);
                        RefreshRates();                        
                     return;
                    }
                 }
              }
           }
        }
     }
   return;
  }
//----------------------------------------------------+
